library DbClient;

uses

  DllMain in 'DLLMAIN.PAS' {Form1},
  Dconnect in 'DCONNECT.PAS' {ConnForm},
  Sockio in '..\COMMON\SOCKIO.PAS',
  Odbctype in '..\COMMON\ODBCTYPE.PAS',
  Odbc_api in '..\COMMON\ODBC_API.PAS',
  Configds in 'CONFIGDS.PAS' {configform};
var
OldExit : Pointer;

{$R *.RES}

exports

{---------------- Core Level API ----------------}

_SQLAllocEnv         name 'SQLALLOCENV',
_SQLAllocStmt        name 'SQLALLOCSTMT',
_SQLBindCol          name 'SQLBINDCOL',
_SQLCancel           name 'SQLCANCEL',
_SQLColAttributes    name 'SQLCOLATTRIBUTES',
_SQLDescribeCol      name 'SQLDESCRIBECOL',
_SQLDisconnect       name 'SQLDISCONNECT',
_SQLError            name 'SQLERROR',
_SQLExecDirect       name 'SQLEXECDIRECT',
{_SQLExecute          name 'SQLEXECUTE',}
_SQLfetch            name 'SQLFETCH',
_SQLFreeConnect      name 'SQLFREECONNECT',
_SQLFreeEnv          name 'SQLFREEENV',
_SQLFreeStmt         name 'SQLFREESTMT',
_SQLGetCursorName    name 'SQLGETCURSORNAME',
_SQLNumResultCols    name 'SQLNUMRESULTCOLS',
{_SQLPrepare          name 'SQLPREPARE',}
_SQLRowCount         name 'SQLROWCOUNT',
{_SQLSetCursorname    name 'SQLSETCURSORNAME',
_SQLSetParam         name 'SQLSETPARAM',}
_SQLTransact         name 'SQLTRANSACT',
_SQLAllocConnect     name 'SQLALLOCCONNECT',
_SQLConnect          name 'SQLCONNECT',


{---------------- Level 1 API -----------------}

_SQLGetFunctions     name 'SQLGETFUNCTIONS',
_SQLColumns          name 'SQLCOLUMNS',
_SQLDriverConnect    name 'SQLDRIVERCONNECT',
_SQLGetConnectOption name 'SQLGETCONNECTOPTION',
{_SQLGetData          name 'SQLGETDATA',}
_SQLGetInfo          name 'SQLGETINFO',
_SQLGetStmtOption    name 'SQLGETSTMTOPTION',
_SQLGetTypeInfo      name 'SQLGETTYPEINFO',
{_SQLParamData        name 'SQLPARAMDATA',
_SQLPutData          name 'SQLPUTDATA',}
_SQLSetConnectOption name 'SQLSETCONNECTOPTION',
_SQLSetStmtOption    name 'SQLSETSTMTOPTION',
_SQLSpecialColumns   name 'SQLSPECIALCOLUMNS',
_SQLStatistics       name 'SQLSTATISTICS',
_SQLTables           name 'SQLTABLES',


{----------------- Level 2 API -----------------}
{
_SQLExtendedFetch    name 'SQLEXTENDEDFETCH',
_SQLMoreResults      name 'SQLMORERESULTS',
_SQLNativeSQL        name 'SQLNATIVESQL',
_SQLNumParams        name 'SQLNUMPARAMS',
_SQLProcedures       name 'SQLPROCEDURES',
_SQLPrimaryKeys      name 'SQLPRIMARYKEYS',
_SQLSetScrollOptions name 'SQLSETSCROLLOPTIONS',
_SQLTablePrivileges  name 'SQLTABLEPRIVILEGES',}

{----------------- SetUp Functions --------------}

_ConfigDSN           name 'CONFIGDSN';



procedure LibExit; far;
begin

     ExitProc := OldExit;
     endproc;
end;


begin
OldExit := ExitProc;
ExitProc := @LibExit;
inifile := nil;
getmem(dataptr1,512);
getmem(dsnname,512);
Sockfd := TSocketIO.Create;
dsnconnect := false;
end.

