{
ODBConnect Client ODBC Driver DLL source code. Version 1.0

                             By

                      Shahedali Moolji
                shahed@giasbm01.vsnl.net.in
             http://members.tripod.com/~shahed

This program and all its documentation is in the public domain.
You may do what you like with it !!.
My only request is for you not to remove this message.

If you find it to be of any interest, as a courtesy, please e-mail
me saying so. It would encourage me to continue to develop
such other s/w which may be of use to you in the future.

Special thanks to :-

Martin Diekhoff [ http://www.geniusworks.com ] without whose help &
encouragment, this would not have been possible.

Sajjad Lateef, for being a wonderful cousin and buying me all the s/w
that I needed for this project.

And to the dWinsock Team [Marc, Keith & Ulf ] for giving us dWinsock &
to the support list members for always being there when I needed them.

Thanks Guys !!

}







unit dllmain;
interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, dWinsock, Inifiles, WSAPI, DWSError,
  dConnect, sockio, odbctype, odbc_api, configds;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Memo1: TMemo;
    ClientSocket1: TClientSocket;
    procedure ClientSocket1Connect(Sender: TObject; Socket: TSocketBase);
    procedure ClientSocket1TimeOut(Sender: TObject; Socket: TSocketBase);
    procedure ClientSocket1Write(Sender: TObject; Socket: TSocketBase);
    procedure ClientSocket1Read(Sender: TObject; Socket: TSocketBase);
    procedure ClientSocket1Disconnect(Sender: TObject;
      Socket: TSocketBase);
  private
    { Private declarations }
  public
    { Public declarations }
  end;


  {---}


procedure endproc; far;
function _Strlen(str : Pchar) : Longint;

{------------ Core & Level 1 API -----------------}

function _SQLAllocEnv(var EnvironmentHandle : SQLHENV ) : SQLRETURN ;
                                            export;
function _SQLAllocConnect(EnvironmentHandle : SQLHENV ;
         var ConnectionHandle : SQLHDBC) : SQLRETURN ; export ;

function _SQLConnect(ConnectionHandle : SQLHDBC ;
                    ServerName : SQLCHARptr ; NameLength1 : SQLSMALLINT;
                    UserName:SQLCHARptr ; NameLength2 : SQLSMALLINT;
                    Authentication: SQLCHARptr; NameLength3 : SQLSMALLINT
         ) : SQLRETURN ; export ;

function _SQLDisconnect(ConnectionHandle : SQLHDBC) : SQLRETURN ; export ;
function _SQLFreeConnect(ConnectionHandle : SQLHDBC) : SQLRETURN ; export ;
function _SQLFreeEnv(EnvironmentHandle : SQLHENV) : SQLRETURN ; export ;
function _SQLGetInfo(ConnectionHandle : SQLHDBC;
         Infotype :SQLUSMALLINT; Infovalue : SQLPOINTER;
         BufferLen : SQLSMALLINT; var stringlen : SQLSMALLINT) :
         SQLRETURN ; export;
function _SQLError(EnvironmentHandle : SQLHENV ;
                   ConnectionHandle : SQLHDBC;
                   StatmentHandle : SQLHSTMT;
                   SQLState : SQLCHARptr;
                   var NativeError : SQLINTEGER;
                   MessageText : SQLCHARptr;
                   BufferLen : SQLSMALLINT;
                   var TextLen : SQLSMALLINT) : SQLRETURN ;
                   export;

function _SQLDriverConnect(hdbc : SQLHDBC; hwnd : SQLHWND;
                          Cstr : SQLCHARptr; Cstrin : SQLSMALLINT;
                          Cstrout : SQLCHARptr; Cstroutmax : SQLSMALLINT;
                          var Cstroutlen : SQLSMALLINT;
                          DriverCompletion : SQLUSMALLINT): SQLRETURN;
                           export;

function _SQLSetConnectOption(ConnectionHandle : SQLHDBC;
                             Option : SQLUSMALLINT;
                             Value : SQLUINTEGER):SQLRETURN; export;

function _SQLAllocStmt(ConnectionHandle : SQLHDBC;
                           var StatementHandle : SQLHSTMT) : SQLRETURN;
                           export;
function _SQLBindCol(StatementHandle : SQLHSTMT;
                    ColumnNumber : SQLUSMALLINT;
                    TargetType : SQLSMALLINT;
                    TargetValue : SQLPOINTER;
                    BufferLen : SQLINTEGER;
                    var StrLen_or_Ind : SQLINTEGER)
                    : SQLRETURN; export;

function _SQLCancel(StatementHandle : SQLHSTMT) : SQLRETURN ; export;

function _SQLColAttributes(StatementHandle : SQLHSTMT;
                          ColumnNumber : SQLUSMALLINT;
                          FieldIdentifier : SQLUSMALLINT;
                          CharacterAttribute : SQLPOINTER;
                          BufferLength : SQLSMALLINT;
                          var StringLength : SQLSMALLINT;
                          NumericAttribute : SQLPOINTER) : SQLRETURN;
                          export;
function _SQLDescribeCol(StatementHandle : SQLHSTMT;
                        ColumnNumber : SQLUSMALLINT;
                        ColumnName : SQLCHARptr;
                        BufferLength : SQLSMALLINT;
                        var NameLength : SQLSMALLINT;
                        var Datatype : SQLSMALLINT;
                        var ColumnSize : SQLUINTEGER;
                        var DecimalDigit : SQLSMALLINT;
                        var Nullable : SQLSMALLINT)
                        : SQLRETURN;export;

function _SQLFetch(StatementHandle : SQLHSTMT): SQLRETURN ; export;
function _SQLFreeStmt(StatementHandle : SQLHSTMT;
                     Option : SQLUSMALLINT) : SQLRETURN ; export ;

function _SQLTables(StatementHandle : SQLHSTMT; CatalogName : SQLCHARptr;
                   NameLength1 : SQLSMALLINT; SchemaName : SQLCHARptr;
                   NameLength2 : SQLSMALLINT; TableName : SQLCHARptr;
                   NameLength3 : SQLSMALLINT; TableType : SQLCHARptr;
                   NameLength4 : SQLSMALLINT) :
                   SQLRETURN; export;

function _SQLGetTypeInfo(StatementHandle : SQLHSTMT ;
                        DataType : SQLSMALLINT) : SQLRETURN;
                        export;

function _SQLExecDirect(StatementHandle : SQLHSTMT;
                       StatementText : SQLCHARptr;
                       TextLength : SQLINTEGER) : SQLRETURN ; export;

function _SQLExecute(StatementHandle : SQLHSTMT) : SQLRETURN ; export;

function _SQLGetCursorName(StatementHandle : SQLHSTMT;
                          CursorName : SQLCHARptr;
                          BufferLength : SQLSMALLINT;
                          var NameLength : SQLSMALLINT) : SQLRETURN;
                          export;

function _SQLNumResultCols(StatementHandle : SQLHSTMT ;
                           var ColumnCount : SQLSMALLINT) : SQLRETURN;
                           export;

function _SQLPrepare(StatementHandle : SQLHSTMT;
                       StatementText : SQLCHARptr;
                       TextLength : SQLINTEGER) : SQLRETURN ; export;

function _SQLRowCount(StatementHandle : SQLHSTMT ;
                     var RowCount : SQLINTEGER) : SQLRETURN;  export ;


function _SQLSetCursorName(StatementHandle : SQLHSTMT;
                          CursorName : SQLCHARptr;
                          NameLength : SQLSMALLINT): SQLRETURN ; export ;

function _SQLSetParam(StatementHandle : SQLHSTMT;
                    ParameterNumber : SQLUSMALLINT;
                    ValueType : SQLSMALLINT;
                    ParameterType : SQLSMALLINT;
                    LengthPrecision : SQLUINTEGER;
                    ParameterScale : SQLSMALLINT;
                    ParameterValue : SQLPOINTER;
                    var StrLen_or_Ind : SQLINTEGER) : SQLRETURN ;
                    export ;

function _SQLTransact(EnvironmentHandle : SQLHENV;
                     ConnectionHandle : SQLHDBC;
                     CompletionType : SQLUSMALLINT): SQLRETURN ; export ;

function _SQLColumns(StatementHandle : SQLHSTMT; CatalogName : SQLCHARptr;
                   NameLength1 : SQLSMALLINT; SchemaName : SQLCHARptr;
                   NameLength2 : SQLSMALLINT; TableName : SQLCHARptr;
                   NameLength3 : SQLSMALLINT; ColumnName : SQLCHARptr;
                   NameLength4 : SQLSMALLINT) :
                   SQLRETURN; export;


function _SQLSpecialColumns(StatementHandle : SQLHSTMT;
           IdentifierType : SQLUSMALLINT; CatalogName : SQLCHARptr;
           NameLength1 : SQLSMALLINT ; SchemaName : SQLCHARptr;
           NameLength2 : SQLSMALLINT ; TableName : SQLCHARptr;
           NameLength3 : SQLSMALLINT ; Scope : SQLUSMALLINT;
           Nullable : SQLUSMALLINT) : SQLRETURN ; export;

function _SQLSetStmtOption (StatementHandle : SQLHSTMT;
                           Option : SQLUSMALLINT ;
                           Value : SQLUINTEGER): SQLRETURN ; export;


function _SQLGetConnectOption (ConnectionHandle : SQLHDBC;
                              Option : SQLUSMALLINT;
                              Value : SQLPOINTER)  : SQLRETURN ; export;

function _SQLGetData(StatementHandle : SQLHSTMT;
                    ColumnNumber : SQLUSMALLINT;
                    TargetType : SQLUSMALLINT;
                    TargetValue : SQLPOINTER;
                    BufferLength : SQLINTEGER;
                    var StrLen_or_Ind : SQLINTEGER) : SQLRETURN; export;

function _SQLGetFunctions(ConnectionHandle : SQLHDBC;
                         FunctionId : SQLUSMALLINT;
                         Supported : SQLPOINTER) : SQLRETURN; export;


function _SQLGetStmtOption(StatementHandle : SQLHSTMT;
                          Option : SQLUSMALLINT;
                          Value : SQLPOINTER) : SQLRETURN;export;



function _SQLParamData(StatementHandle : SQLHSTMT ;
                      Value : SQLPOINTER ) : SQLRETURN;export;

function _SQLPutData(StatementHandle : SQLHSTMT;
                    Data : SQLPOINTER;
                    StrLen_or_Ind : SQLINTEGER) : SQLRETURN; export;

function _SQLStatistics(StatementHandle : SQLHSTMT;
                       CatalogName : SQLCHARptr ;
                       NameLength1 : SQLSMALLINT;
                       SchemaName : SQLCHARptr;
                       NameLength2 : SQLSMALLINT;
                       TableName  : SQLCHARptr;
                       NameLength3 : SQLSMALLINT;
                       Unique : SQLUSMALLINT;
                       Reserved : SQLUSMALLINT) : SQLRETURN; export;

{---------------- Level 2 API ----------------------}

{ Implemented exclusively by Driver Manager as per SDK documentation
function _SQLDataSources       : SQLRETURN; export;
function _SQLDrivers           : SQLRETURN; export;
}

function _SQLExtendedFetch(hstmt        : SQLHSTMT;
                           fFetchType   : SQLUSMALLINT;
                           iRow         : SQLINTEGER;
                           var pcrow        : SQLUINTEGER;
                           var rgfRowStatus : SQLUSMALLINT) : SQLRETURN;
                           export;

function _SQLMoreResults(hstmt : SQLHSTMT): SQLRETURN; export;


function _SQLNativeSQL(hdbc          : SQLHDBC;
                       szSqlStrIn    : SQLCHARptr;
                       cbSqlStrIn    : SQLINTEGER;
                       szSqlStr      : SQLCHARptr;
                       cbSqlStrMax   : SQLINTEGER;
                       var pcbSqlStr : SQLINTEGER) : SQLRETURN; export;

function _SQLNumParams(hstmt : SQLHSTMT ; var pcpar : SQLSMALLINT)
                                     : SQLRETURN; export;

function _SQLProcedures(hstmt           : SQLHSTMT;
                        szCatalogName   : SQLCHARptr;
                        cbCatalogName   : SQLSMALLINT;
                        szSchemaName    : SQLCHARptr;
                        cbSchemaName    : SQLSMALLINT;
                        szProcName      : SQLCHARptr;
                        cbProcName      : SQLSMALLINT)
                        : SQLRETURN; export;

function _SQLPrimaryKeys(hstmt         : SQLHSTMT;
                         szCatalogName : SQLCHARptr;
                         cbCatalogName : SQLSMALLINT;
                         szSchemaName  : SQLCHARptr;
                         cbSchemaName  : SQLSMALLINT;
                         szTableName   : SQLCHARptr;
                         cbTableName   : SQLSMALLINT): SQLRETURN; export;

function _SQLSetScrollOptions(hstmt         : SQLHSTMT;
                              fConcurrency  : SQLUSMALLINT;
                              crowKeyset    : SQLINTEGER;
                              crowRowset    : SQLSMALLINT)
                              : SQLRETURN; export;

function _SQLTablePrivileges(hstmt         : SQLHSTMT;
                             szCatalogName : SQLCHARptr;
                             cbCatalogName : SQLSMALLINT;
                             szSchemaName  : SQLCHARptr;
                             cbSchemaName  : SQLSMALLINT;
                             szTableName   : SQLCHARptr;
                             cbTableName   : SQLSMALLINT)
                               : SQLRETURN; export;


{------------ SetUp Functions ----------------}

function _ConfigDSN(hwndParent : hwnd; fRequest : WORD;
                   const lpszDriver : Pchar;
                   const lpszAttributes : PChar) : BOOL ; export ;

type
CstatusTypes = (Connected,Disconnected,TimeOut);

var
  Form1: TForm1;
  inifile : Tinifile;
  Msg : TMsg;
  dataptr1 : pchar;
  sockfd : TSocketio;
  cwait,WaitFlag : boolean;
  cstatus : CstatusTypes;
  dsnconnect : boolean;
  Secvalues : TStringlist;
  dsnname : Pchar;




implementation
{$R *.DFM}

function _SQLAllocEnv(var EnvironmentHandle : SQLHENV ) : SQLRETURN ;
var
henv : SQLHENV;
tmp : string;
begin
     Secvalues := TStringlist.Create;
     inifile := TInifile.Create('ODBCCONN.INI');
     inifile.ReadSectionValues('Settings',SecValues);
     inifile.free;


     if(GetModuleUsage(hinstance) > 1)
     then
     begin
         result := -1;
         exit;
     end;

     cwait := true;

               Form1 :=
               Tform1.Create(Application);

               if SecValues.Values['APIServer'] = '' then
               SecValues.Values['APIServer'] := '127.0.0.1';

               Form1.ClientSocket1.Address :=
               SecValues.Values['APIServer'];

               Form1.ClientSocket1.Open(TStreamSocket);

               while cwait do
               begin
                if (peekmessage(Msg,0,WM_USER+1111,WM_USER+1111,PM_REMOVE))
                then
                                dispatchmessage(Msg);
               end;

               if Form1.ClientSocket1.Connected then
               else
               begin
               cstatus := Disconnected;
               Form1.Free;
               Result := -1;
               exit;
               end;

     Sockfd.SendFuncHeader(fSQLAllocEnv);
     Result := Sockfd.SendExec;
     Sockfd.SetRecvBuff(@EnvironmentHandle);
     Sockfd.SendRecvHeader(1);
     Sockfd.SendFuncDone;

     if (cstatus = Disconnected) or (cstatus = Timeout) then
     Result := -1;




end;



function _SQLAllocConnect(EnvironmentHandle : SQLHENV ;
         var ConnectionHandle : SQLHDBC) : SQLRETURN ;
var
hdbc : SQLHDBC;
begin

     if (cstatus = Disconnected) or (cstatus = Timeout) then
     begin
     Result := 1; {Should be -1, but DBD doesnt seem to agree !!}
     ConnectionHandle := 0;
     exit;
     end;


     hdbc := 0;
     Sockfd.SendFuncHeader(fSQLAllocConnect);
     Sockfd.SendParam(1,sizeof(SQLHENV),eNone,0,0,@EnvironmentHandle);
     Result := Sockfd.SendExec;
     Sockfd.SetRecvBuff(@hdbc);
     Sockfd.SendRecvHeader(2);
     Sockfd.SendFuncDone;
     ConnectionHandle := hdbc;

     if (cstatus = Disconnected) or (cstatus = Timeout) then
     Result := -1;

end;



function _SQLConnect(ConnectionHandle : SQLHDBC ;
                    ServerName : SQLCHARptr ; NameLength1 : SQLSMALLINT;
                    UserName : SQLCHARptr; NameLength2 : SQLSMALLINT;
                    Authentication : SQLCHARptr; NameLength3 : SQLSMALLINT
         ) : SQLRETURN ;

var
rdsn : string;

begin



     if (cstatus = Disconnected) or (cstatus = Timeout) then
     begin
     Result := 1; {Should be -1. Refer to SQLAllocStmt}
     exit;
     end;

     rdsn := SecValues.Values['RemoteDSN'];

     StrPCopy(dataptr1,rdsn);
     NameLength1 := StrLen(dataptr1);

     Sockfd.SendFuncHeader(fSQLConnect);
     Sockfd.SendParam(1,sizeof(SQLHDBC),eNone,0,0,@ConnectionHandle);
     Sockfd.SendParam(2,_strlen(dataptr1),eNone,0,0,dataptr1);
     Sockfd.SendParam(3,sizeof(NameLength1),eNone,0,0,@NameLength1);
     Sockfd.SendParam(4,_strlen(UserName),eNone,0,0,UserName);
     Sockfd.SendParam(5,sizeof(NameLength2),eNone,0,0,@NameLength2);
     Sockfd.SendParam(6,_strlen(Authentication),eNone,0,0,Authentication);
     Sockfd.SendParam(7,sizeof(NameLength3),eNone,0,0,@NameLength3);
     Result := Sockfd.SendExec;
     Sockfd.SendFuncDone;

     if Result > -1  then dsnconnect := true;

     if (cstatus = Disconnected) or (cstatus = Timeout) then
     Result := -1;


end;



function _SQLDisconnect(ConnectionHandle : SQLHDBC) : SQLRETURN ;
begin

     if (cstatus = Disconnected) or (cstatus = Timeout) then
     begin
     Result := 0; {Do nothing and just continue}
     exit;
     end;


     Sockfd.SendFuncHeader(fSQLDisconnect);
     Sockfd.SendParam(1,sizeof(SQLHDBC),eNone,0,0,@Connectionhandle);
     Result := Sockfd.SendExec;
     Sockfd.SendFuncDone;
     if result > -1 then dsnconnect := false;

     if (cstatus = Disconnected) or (cstatus = Timeout) then
     Result := -1;


end;
function _SQLFreeConnect(ConnectionHandle : SQLHDBC) : SQLRETURN ;
begin

     if (cstatus = Disconnected) or (cstatus = Timeout) then
     begin
     Result := 0; {Do nothing and just exit gracefully}
     exit;
     end;


     Sockfd.SendFuncHeader(fSQLFreeConnect);
     Sockfd.SendParam(1,sizeof(SQLHDBC),eNone,0,0,@Connectionhandle);
     Result := Sockfd.SendExec;
     Sockfd.SendFuncDone;

     if (cstatus = Disconnected) or (cstatus = Timeout) then
     Result := -1;


end;
function _SQLFreeEnv(EnvironmentHandle : SQLHENV) : SQLRETURN ;
var
cx : Integer;
begin

     if (cstatus = Disconnected) or (cstatus = Timeout) then
     begin
     Result := 0; { Do nothing, but try & close the Form}
     end
     else
     begin
     Sockfd.SendFuncHeader(fSQLFreeEnv);
     Sockfd.SendParam(1,sizeof(SQLHDBC),eNone,0,0,@EnvironMentHandle);
     Result := Sockfd.SendExec;
     Sockfd.SendFuncDone;
     end;


      try
      Form1.ClientSocket1.close;
      except
      begin
      end;
      end;

      Form1.close;
      Form1.Free;
      Form1 := nil;





end;


function _SQLGetInfo(ConnectionHandle : SQLHDBC;
         Infotype :SQLUSMALLINT; Infovalue : SQLPOINTER;
         BufferLen : SQLSMALLINT; var stringlen : SQLSMALLINT) :
         SQLRETURN ;
var
l : SQLSMALLINT;
ptr : pointer;

begin

     if (cstatus = Disconnected) or (cstatus = Timeout) then
     begin
     Result := -1; exit;
     end;



     ptr := @stringlen;

     { Getinfo values 23 & 24 values not avaliable at time of SQLConnect }
     { Patch for compatibility with SST Inc ODBC Trace utility }
     if not (dsnconnect) then begin
     if (infotype = 23) or (infotype = 24) then begin
     Result := -1;
     exit;
     end;
     end;


     {No matter what remote DSN we are connected to, we must always
     tell applications on the client PC that they are connected to
     the local ODBConnect DSN as defined in ODBC.INI}
     if (infotype = 2) and dsnconnect then begin
     if assigned(infovalue) then
     StrLCopy(infovalue,dsnname,bufferlen);
     stringlen := Strlen(infovalue);
     result := 0;
     exit
     end;


     { Patch for compatibility with SST Inc ODBC Trace utility }
     if (infotype = 77) then begin  {Driver Dll version}
     strPcopy(infovalue,'01.00');
     stringlen := 5;
     Result := 0;
     exit;
     end;



     Sockfd.SendFuncHeader(fSQLGetInfo);
     Sockfd.SendParam(1,sizeof(SQLHDBC),eNone,0,0,@ConnectionHandle);
     Sockfd.SendParam(2,sizeof(SQLUSMALLINT),eNone,0,0,@InfoType);
     Sockfd.SendParam(4,sizeof(SQLSMALLINT),eNone,0,0,@BufferLen);
     Result := Sockfd.SendExec;
     if assigned(infovalue) then begin
      Sockfd.SetRecvBuff(InfoValue);
     Sockfd.SendRecvHeader(3);
     end;
     {Do not assign val to strlen for 16&32 bit values }
      if assigned(ptr) then begin
     Sockfd.SetRecvBuff(@StringLen);
     Sockfd.SendRecvHeader(5);
     end;
     Sockfd.SendFuncdone;


     if (cstatus = Disconnected) or (cstatus = Timeout) then
     begin
     Result := -1;
     end;




end;


function _SQLSetConnectOption(ConnectionHandle : SQLHDBC;
                             Option : SQLUSMALLINT;
                             Value : SQLUINTEGER):SQLRETURN;

begin

     if (cstatus = Disconnected) or (cstatus = Timeout) then
     begin
     Result := -1;
     exit;
     end;


     Sockfd.SendFuncHeader(fSQLSetConnectOption);
     Sockfd.SendParam(1,sizeof(SQLHDBC),eNone,0,0,@ConnectionHandle);
     Sockfd.SendParam(2,sizeof(SQLUSMALLINT),eNone,0,0,@Option);
     Sockfd.SendParam(3,sizeof(SQLUINTEGER),eNone,0,0,@Value);
     Result := Sockfd.SendExec;
     Sockfd.SendFuncDone;
     if (cstatus = Disconnected) or (cstatus = Timeout) then
     Result := -1;


end;


function _SQLDriverConnect(hdbc : SQLHDBC; hwnd : SQLHWND;
                          Cstr : SQLCHARptr; Cstrin : SQLSMALLINT;
                          Cstrout : SQLCHARptr; Cstroutmax : SQLSMALLINT;
                          var Cstroutlen : SQLSMALLINT;
                          DriverCompletion : SQLUSMALLINT): SQLRETURN;
var
pstr,tstr,tstr1 : Pchar;
FResult : Integer;
tempstr : string;
begin

     if (cstatus = Disconnected) or (cstatus = Timeout) then
     begin
     Result := -1;
     exit;
     end;


     Result := 0;

          GetMem(pstr,512);



          ConnForm := TConnForm.Create(Application);
          ConnForm.DSNEdit.Text  := SecValues.Values['RemoteDSN'];
          ConnForm.UIDEdit.Text  := SecValues.Values['UID'];
          ConnForm.CstrEdit.Text := SecValues.Values['ConnectString'];

          Fresult := ConnForm.Showmodal;

          tempstr := 'DSN='+ConnForm.DSNEdit.Text;

          if Connform.UIDEdit.Text <> '' then
          tempstr := tempstr +';UID='+Connform.UIDEdit.Text;

          if Connform.PWDEdit.Text <> '' then
          tempstr := tempstr +';PWD='+Connform.PWDEdit.Text;

          if Connform.CstrEdit.Text <> '' then
          tempstr := tempstr +';'+Connform.CstrEdit.Text;


          StrPCopy(pstr,tempstr);
          if FResult <> mrOk then
          begin
           Cstrout^  := #0;
           CstroutLen := 0;
           Result := 100;
           exit;
           end;
           ConnForm.Free;


         Cstrin := _strlen(pstr);
         Sockfd.SendFuncHeader(fSQLDriverConnect);
         Sockfd.SendParam(1,sizeof(SQLHDBC),eNone,0,0,@hdbc);
         Sockfd.SendParam(3,cstrin+1,eNone,0,0,pstr);
         Sockfd.SendParam(4,sizeof(SQLSMALLINT),eNone,0,0,@Cstrin);
         Sockfd.SendParam(6,sizeof(SQLSMALLINT),eNone,0,0,@CstroutMax);
         Result := Sockfd.SendExec;
         Sockfd.SetRecvBuff(Cstrout);
         Sockfd.SendRecvheader(5);
         Sockfd.SetRecvBuff(@Cstroutlen);
         Sockfd.SendRecvheader(6);
         Sockfd.SendFuncDone;
         FreeMem(Pstr,512);
         StrCopy(CstrOut,Cstr);
         Cstroutlen := Cstrin;

         strpcopy(dataptr1,'DSN=');
         tstr := StrPos(cstr,dataptr1);
         if tstr <> nil then begin
         Inc(tstr,4);
         tstr1 := StrScan(tstr,';');
         if tstr1 <> nil then tstr1^ := #0;
         StrCopy(dsnname,tstr);
         end
         else
         StrPCopy(dsnname,'');

         if Result > -1  then dsnconnect := true;


     if (cstatus = Disconnected) or (cstatus = Timeout) then
     Result := -1;


end;


function _SQLAllocStmt(ConnectionHandle : SQLHDBC;
                           var StatementHandle : SQLHSTMT) : SQLRETURN;
begin

     if (cstatus = Disconnected) or (cstatus = Timeout) then
     begin
     StatementHandle := 0; {0 = SQL_NULL_HSTMT [Return a Null Handle]}

     Result := 1; {Should return -1, but Delphi's Database Desktop
                   seems to think that this function always succeeds.
                   While MS-Query does not try to proceed further if
                   it encounters an error, DBD executes a number of
                   functions before it responds to an error !!
                   So, for keeping DBD in good spirits, we must return 1}
     exit;
     end;


Sockfd.SendFuncHeader(fSQLAllocStmt);
Sockfd.SendParam(1,sizeof(SQLHDBC),eNone,0,0,@ConnectionHandle);
Result := Sockfd.SendExec;
Sockfd.SetRecvBuff(@StatementHandle);
Sockfd.SendRecvHeader(2);
Sockfd.SendFuncDone;

     if (cstatus = Disconnected) or (cstatus = Timeout) then
     Result := -1;


end;

function _SQLBindCol(StatementHandle : SQLHSTMT;
                    ColumnNumber : SQLUSMALLINT;
                    TargetType : SQLSMALLINT;
                    TargetValue : SQLPOINTER;
                    BufferLen : SQLINTEGER;
                    var StrLen_or_Ind : SQLINTEGER)
                    : SQLRETURN;
var
ptr1 : Pchar;
BuffAddr : longint;
begin
     if (cstatus = Disconnected) or (cstatus = Timeout) then
     begin
     Result := -1;
     exit;
     end;



     ptr1 := @StrLen_or_Ind;
     MemMove(@BuffAddr,@ptr1,sizeof(SQLPOINTER));
     Sockfd.SendFuncHeader(fSQLBindCol);
     Sockfd.SendParam(1,sizeof(SQLHSTMT),eNone,0,0,@StatementHandle);
     Sockfd.SendParam(2,sizeof(SQLUSMALLINT),eNone,0,0,@ColumnNumber);
     Sockfd.SendParam(3,sizeof(SQLSMALLINT),eNone,0,0,@TargetType);
     Sockfd.SendParam(4,sizeof(SQLPOINTER),eNone,0,0,@TargetValue);
     Sockfd.SendParam(5,sizeof(SQLINTEGER),eNone,0,0,@BufferLen);
     Sockfd.SendParam(6,sizeof(SQLPOINTER),eNone,0,0,@BuffAddr);
     Result := Sockfd.SendExec;
     Sockfd.SendFuncDone;

     if (cstatus = Disconnected) or (cstatus = Timeout) then
     Result := -1;



end;

function _SQLCancel(StatementHandle : SQLHSTMT) : SQLRETURN ;
begin

     if (cstatus = Disconnected) or (cstatus = Timeout) then
     begin
     Result := 0;
     exit;
     end;


     Sockfd.SendFuncHeader(fSQLCancel);
     Sockfd.SendParam(1,sizeof(SQLHSTMT),eNone,0,0,@StatementHandle);
     Result := Sockfd.SendExec;
     Sockfd.SendFuncDone;



end;


function _SQLColAttributes(StatementHandle : SQLHSTMT;
                          ColumnNumber : SQLUSMALLINT;
                          FieldIdentifier : SQLUSMALLINT;
                          CharacterAttribute : SQLPOINTER;
                          BufferLength : SQLSMALLINT;
                          var StringLength : SQLSMALLINT;
                          NumericAttribute : SQLPOINTER) : SQLRETURN;
begin
     if (cstatus = Disconnected) or (cstatus = Timeout) then
     begin
     Result := -1;
     exit;
     end;


     Sockfd.SendFuncHeader(fSQLColAttributes);
     Sockfd.SendParam(1,sizeof(SQLHSTMT),eNone,0,0,@StatementHandle);
     Sockfd.SendParam(2,sizeof(SQLUSMALLINT),eNone,0,0,@ColumnNumber);
     Sockfd.SendParam(3,sizeof(SQLUSMALLINT),eNone,0,0,@FieldIdentifier);
     {Just to inform the server param 4 is null or not}
     Sockfd.SendParam(4,1,eNone,0,0,CharacterAttribute);
     Sockfd.SendParam(5,sizeof(SQLSMALLINT),eNone,0,0,@BufferLength);
    {Just to inform the server if params 6&7 are null or not}
     Sockfd.SendParam(6,1,eNone,0,0,@StringLength);
     Sockfd.SendParam(7,1,eNone,0,0,NumericAttribute);
     Result := Sockfd.SendExec;
     Sockfd.SetRecvBuff(CharacterAttribute);
     Sockfd.SendRecvHeader(4);
     Sockfd.SetRecvBuff(@StringLength);
     Sockfd.SendRecvHeader(6);
     Sockfd.SetRecvBuff(NumericAttribute);
     Sockfd.SendRecvHeader(7);
     Sockfd.SendFuncDone;

     if (cstatus = Disconnected) or (cstatus = Timeout) then
     Result := -1;



end;
function _SQLDescribeCol(StatementHandle : SQLHSTMT;
                        ColumnNumber : SQLUSMALLINT;
                        ColumnName : SQLCHARptr;
                        BufferLength : SQLSMALLINT;
                        var NameLength : SQLSMALLINT;
                        var Datatype : SQLSMALLINT;
                        var ColumnSize : SQLUINTEGER;
                        var DecimalDigit : SQLSMALLINT;
                        var Nullable : SQLSMALLINT)
                        : SQLRETURN;
begin

     if (cstatus = Disconnected) or (cstatus = Timeout) then
     begin
     Result := -1;
     exit;
     end;

Sockfd.SendFuncHeader(fSQLDescribeCol);
Sockfd.SendParam(1,sizeof(SQLHSTMT),eNone,0,0,@StatementHandle);
Sockfd.SendParam(2,sizeof(SQLUSMALLINT),eNone,0,0,@ColumnNumber);
Sockfd.SendParam(4,sizeof(SQLSMALLINT),eNone,0,0,@BufferLength);
Result := Sockfd.SendExec;
Sockfd.SetRecvBuff(ColumnName);
Sockfd.SendRecvHeader(3);
Sockfd.SetRecvBuff(@NameLength);
Sockfd.SendRecvHeader(5);
Sockfd.SetRecvBuff(@Datatype);
Sockfd.SendRecvHeader(6);
Sockfd.SetRecvBuff(@ColumnSize);
Sockfd.SendRecvHeader(7);
Sockfd.SetRecvBuff(@DecimalDigit);
Sockfd.SendRecvHeader(8);
Sockfd.SetRecvBuff(@Nullable);
Sockfd.SendRecvHeader(9);
Sockfd.SendFuncDone;


     if (cstatus = Disconnected) or (cstatus = Timeout) then
     Result := -1;

end;



function _SQLError(EnvironmentHandle : SQLHENV ;
                   ConnectionHandle : SQLHDBC;
                   StatmentHandle : SQLHSTMT;
                   SQLState : SQLCHARptr;
                   var NativeError : SQLINTEGER;
                   MessageText : SQLCHARptr;
                   BufferLen : SQLSMALLINT;
                   var TextLen : SQLSMALLINT) : SQLRETURN ;

begin


     if (cstatus = Disconnected) or (cstatus = Timeout) then
     begin

          if SQLState <> nil then
          StrPCopy(SQLState,'S1000');

          if (MessageText <> nil) and (@Bufferlen <> nil) then
          begin
               StrPLCopy(MessageText,
'[ODBConnect] TCP/IP Error : Disconnected from Server. Restart Windows !',
               BufferLen);
               TextLen := StrLen(MessageText);

          end;
          result := 100;


         exit;
     end;


     Sockfd.SendFuncHeader(fSQLError);
     Sockfd.SendParam(1,sizeof(SQLHENV),eNone,0,0,@Environmenthandle);
     Sockfd.SendParam(2,sizeof(SQLHDBC),eNone,0,0,@ConnectionHandle);
     Sockfd.SendParam(3,sizeof(SQLHSTMT),eNone,0,0,@StatmentHandle);
     Sockfd.SendParam(4,1,eNone,0,0,SQLState);
     Sockfd.SendParam(5,sizeof(NativeError),eNone,0,0,@NativeError);
     Sockfd.SendParam(6,1,eNone,0,0,MessageText);
     Sockfd.SendParam(7,sizeof(BufferLen),eNone,0,0,@BufferLen);
     Sockfd.SendParam(8,sizeof(TextLen),eNone,0,0,@TextLen);



     Result := Sockfd.SendExec;


     Sockfd.SetRecvBuff(SQLState);
     Sockfd.SendRecvHeader(4);
     Sockfd.SetRecvBuff(@NativeError);
     Sockfd.SendRecvHeader(5);
     Sockfd.SetRecvBuff(MessageText);
     Sockfd.SendRecvHeader(6);
     Sockfd.SetRecvBuff(@TextLen);
     Sockfd.SendRecvHeader(8);
     Sockfd.SendFuncDone;


     if (cstatus = Disconnected) or (cstatus = Timeout) then
     Result := -1;


end;

function _SQLExecDirect(StatementHandle : SQLHSTMT;
                       StatementText : SQLCHARptr;
                       TextLength : SQLINTEGER) : SQLRETURN ;
begin

     if (cstatus = Disconnected) or (cstatus = Timeout) then
     begin
     Result := -1;
     exit;
     end;


     Sockfd.SendFuncHeader(fSQLExecDirect);
     Sockfd.SendParam(1,sizeof(SQLHSTMT),eNone,0,0,@StatementHandle);
     Sockfd.SendParam(2,_strlen(StatementText),eNone,0,0,StatementText);
     Sockfd.SendParam(3,sizeof(SQLINTEGER),eNone,0,0,@TextLength);
     Result := Sockfd.SendExec;
     Sockfd.SendFuncDone;

     if (cstatus = Disconnected) or (cstatus = Timeout) then
     Result := -1;


end;

function _SQLExecute(StatementHandle : SQLHSTMT) : SQLRETURN ;
begin
end;

function _SQLFetch(StatementHandle : SQLHSTMT): SQLRETURN ;
begin
     if (cstatus = Disconnected) or (cstatus = Timeout) then
     begin
     Result := -1;
     exit;
     end;


     Sockfd.SendFuncHeader(fSQLFetch);
     Sockfd.SendParam(1,sizeof(SQLHSTMT),eNone,0,0,@StatementHandle);
     Result := Sockfd.SendExec;

     if (Result > -1) and (Result < 3) then
     Sockfd.SendHeaderUpdt;
     Sockfd.SendFuncDone;


     if (cstatus = Disconnected) or (cstatus = Timeout) then
     Result := -1;


end;


function _SQLFreeStmt(StatementHandle : SQLHSTMT;
                     Option : SQLUSMALLINT) : SQLRETURN ;
begin
     if (cstatus = Disconnected) or (cstatus = Timeout) then
     begin
     Result := 0;
     exit;
     end;


Sockfd.SendFuncHeader(fSQLFreeStmt);
Sockfd.SendParam(1,sizeof(SQLHSTMT),eNone,0,0,@StatementHandle);
Sockfd.SendParam(2,sizeof(SQLUSMALLINT),eNone,0,0,@Option);
Result := Sockfd.SendExec;
Sockfd.SendFuncDone;

     if (cstatus = Disconnected) or (cstatus = Timeout) then
     Result := -1;


end;

function _SQLGetCursorName(StatementHandle : SQLHSTMT;
                          CursorName : SQLCHARptr;
                          BufferLength : SQLSMALLINT;
                          var NameLength : SQLSMALLINT) : SQLRETURN;
begin
end;

function _SQLNumResultCols(StatementHandle : SQLHSTMT ;
                           var ColumnCount : SQLSMALLINT) : SQLRETURN;
begin

     if (cstatus = Disconnected) or (cstatus = Timeout) then
     begin
     Result := -1;
     exit;
     end;

Sockfd.SendFuncHeader(fSQLNumResultCol);
Sockfd.SendParam(1,sizeof(SQLHSTMT),eNone,0,0,@StatementHandle);
Result := Sockfd.SendExec;
Sockfd.SetRecvBuff(@ColumnCount);
Sockfd.SendRecvHeader(2);
Sockfd.SendFuncDone;

     if (cstatus = Disconnected) or (cstatus = Timeout) then
     Result := -1;


end;


function _SQLPrepare(StatementHandle : SQLHSTMT;
                       StatementText : SQLCHARptr;
                       TextLength : SQLINTEGER) : SQLRETURN ;
begin
end;

function _SQLRowCount(StatementHandle : SQLHSTMT ;
                     var RowCount : SQLINTEGER) : SQLRETURN;
begin
     if (cstatus = Disconnected) or (cstatus = Timeout) then
     begin
     Result := -1;
     exit;
     end;


     Sockfd.SendFuncHeader(fSQLRowCount);
     Sockfd.SendParam(1,sizeof(SQLHSTMT),eNone,0,0,@StatementHandle);
     Result := Sockfd.SendExec;
     Sockfd.SetRecvBuff(@RowCount);
     Sockfd.SendRecvheader(2);
     Sockfd.SendFuncDone;

     if (cstatus = Disconnected) or (cstatus = Timeout) then
     Result := -1;



end;

function _SQLSetCursorName(StatementHandle : SQLHSTMT;
                          CursorName : SQLCHARptr;
                          NameLength : SQLSMALLINT): SQLRETURN ;
begin
end;

function _SQLSetParam(StatementHandle : SQLHSTMT;
                    ParameterNumber : SQLUSMALLINT;
                    ValueType : SQLSMALLINT;
                    ParameterType : SQLSMALLINT;
                    LengthPrecision : SQLUINTEGER;
                    ParameterScale : SQLSMALLINT;
                    ParameterValue : SQLPOINTER;
                    var StrLen_or_Ind : SQLINTEGER) : SQLRETURN ;
begin

end;

function _SQLTransact(EnvironmentHandle : SQLHENV;
                     ConnectionHandle : SQLHDBC;
                     CompletionType : SQLUSMALLINT): SQLRETURN ;
begin

     if (cstatus = Disconnected) or (cstatus = Timeout) then
     begin
     Result := -1; {Should this also return 0 ??}
     exit;
     end;


     Sockfd.SendFuncHeader(fSQLTransact);
     Sockfd.SendParam(1,sizeof(SQLHENV),eNone,0,0,@EnvironmentHandle);
     Sockfd.SendParam(2,sizeof(SQLHDBC),eNone,0,0,@ConnectionHandle);
     Sockfd.SendParam(3,sizeof(SQLUSMALLINT),eNone,0,0,@CompletionType);
     Result := Sockfd.SendExec;
     Sockfd.SendFuncDone;

     if (cstatus = Disconnected) or (cstatus = Timeout) then
     Result := -1;

end;

function _SQLTables(StatementHandle : SQLHSTMT; CatalogName : SQLCHARptr;
                   NameLength1 : SQLSMALLINT; SchemaName : SQLCHARptr;
                   NameLength2 : SQLSMALLINT; TableName : SQLCHARptr;
                   NameLength3 : SQLSMALLINT; TableType : SQLCHARptr;
                   NameLength4: SQLSMALLINT) :
                   SQLRETURN;
begin

     if (cstatus = Disconnected) or (cstatus = Timeout) then
     begin
     Result := -1;
     exit;
     end;


     Sockfd.SendFuncHeader(fSQLTables);
     Sockfd.SendParam(1,sizeof(SQLHSTMT),eNone,0,0,@StatementHandle);
     Sockfd.Sendparam(2,_StrLen(CatalogName),eNone,0,0,CatalogName);
     Sockfd.SendParam(3,sizeof(SQLSMALLINT),eNone,0,0,@NameLength1);
     Sockfd.Sendparam(4,_StrLen(SchemaName),eNone,0,0,SchemaName);
     Sockfd.SendParam(5,sizeof(SQLSMALLINT),eNone,0,0,@NameLength2);
     Sockfd.Sendparam(6,_StrLen(TableName),eNone,0,0,TableName);
     Sockfd.SendParam(7,sizeof(SQLSMALLINT),eNone,0,0,@NameLength3);
     Sockfd.Sendparam(8,_StrLen(TableType),eNone,0,0,TableType);
     Sockfd.SendParam(9,sizeof(SQLSMALLINT),eNone,0,0,@NameLength4);
     Result := Sockfd.SendExec;
     Sockfd.SendFuncDone;

     if (cstatus = Disconnected) or (cstatus = Timeout) then
     Result := -1;


end;

function _SQLGetTypeInfo(StatementHandle : SQLHSTMT ;
                        DataType : SQLSMALLINT) : SQLRETURN;
begin

     if (cstatus = Disconnected) or (cstatus = Timeout) then
     begin
     Result := -1; {Previously -2}
     exit;
     end;


Sockfd.SendFuncHeader(fSQLGetTypeInfo);
Sockfd.SendParam(1,sizeof(SQLHSTMT),eNone,0,0,@StatementHandle);
Sockfd.SendParam(2,sizeof(SQLSMALLINT),eNone,0,0,@Datatype);
Result := Sockfd.SendExec;
Sockfd.SendFuncDone;

     if (cstatus = Disconnected) or (cstatus = Timeout) then
     Result := -1;


end;
function _SQLColumns(StatementHandle : SQLHSTMT; CatalogName : SQLCHARptr;
                   NameLength1 : SQLSMALLINT; SchemaName : SQLCHARptr;
                   NameLength2 : SQLSMALLINT; TableName : SQLCHARptr;
                   NameLength3 : SQLSMALLINT; ColumnName : SQLCHARptr;
                   NameLength4 : SQLSMALLINT) :
                   SQLRETURN;
begin

     if (cstatus = Disconnected) or (cstatus = Timeout) then
     begin
     Result := -1;
     exit;
     end;


    Sockfd.SendFuncHeader(fSQLColumns);
    Sockfd.SendParam(1,sizeof(SQLHSTMT),eNone,0,0,@StatementHandle);
    Sockfd.SendParam(2,_Strlen(CatalogName),eNone,0,0,CatalogName);
    Sockfd.SendParam(3,sizeof(SQLSMALLINT),eNone,0,0,@NameLength1);
    Sockfd.SendParam(4,_Strlen(SchemaName),eNone,0,0,SchemaName);
    Sockfd.SendParam(5,sizeof(SQLSMALLINT),eNone,0,0,@NameLength2);
    Sockfd.SendParam(6,_Strlen(TableName),eNone,0,0,TableName);
    Sockfd.SendParam(7,sizeof(SQLSMALLINT),eNone,0,0,@NameLength3);
    Sockfd.SendParam(8,_Strlen(ColumnName),eNone,0,0,ColumnName);
    Sockfd.SendParam(9,sizeof(SQLSMALLINT),eNone,0,0,@NameLength4);
    Result := Sockfd.SendExec;
    Sockfd.SendFuncDone;

     if (cstatus = Disconnected) or (cstatus = Timeout) then
     Result := -1;


end;
function _SQLSpecialColumns(StatementHandle : SQLHSTMT;
           IdentifierType : SQLUSMALLINT; CatalogName : SQLCHARptr;
           NameLength1 : SQLSMALLINT ; SchemaName : SQLCHARptr;
           NameLength2 : SQLSMALLINT ; TableName : SQLCHARptr;
           NameLength3 : SQLSMALLINT ; Scope : SQLUSMALLINT;
           Nullable : SQLUSMALLINT) : SQLRETURN ;
begin
     if (cstatus = Disconnected) or (cstatus = Timeout) then
     begin
     Result := -1;
     exit;
     end;


    Sockfd.SendFuncHeader(fSQLSpecialColumns);
    Sockfd.SendParam(1,sizeof(SQLHSTMT),eNone,0,0,@StatementHandle);
    Sockfd.SendParam(2,sizeof(SQLUSMALLINT),eNone,0,0,@IdentifierType);
    Sockfd.SendParam(3,_Strlen(CatalogName),eNone,0,0,CatalogName);
    Sockfd.SendParam(4,sizeof(SQLSMALLINT),eNone,0,0,@NameLength1);
    Sockfd.SendParam(5,_Strlen(SchemaName),eNone,0,0,SchemaName);
    Sockfd.SendParam(6,sizeof(SQLSMALLINT),eNone,0,0,@NameLength2);
    Sockfd.SendParam(7,_Strlen(TableName),eNone,0,0,TableName);
    Sockfd.SendParam(8,sizeof(SQLSMALLINT),eNone,0,0,@NameLength3);
    Sockfd.SendParam(9,sizeof(Scope),eNone,0,0,@Scope);
    Sockfd.SendParam(10,sizeof(Nullable),eNone,0,0,@Nullable);
    Result := Sockfd.SendExec;
    Sockfd.SendFuncDone;



     if (cstatus = Disconnected) or (cstatus = Timeout) then
     Result := -1;



end;

function _SQLSetStmtOption (StatementHandle : SQLHSTMT;
                           Option : SQLUSMALLINT ;
                           Value : SQLUINTEGER): SQLRETURN ;

begin
     if (cstatus = Disconnected) or (cstatus = Timeout) then
     begin
     Result := -1;
     exit;
     end;


      Sockfd.SendFuncHeader(fSQLSetStmtOption);
      Sockfd.SendParam(1,sizeof(SQLHSTMT),eNone,0,0,@StatementHandle);
      Sockfd.SendParam(2,sizeof(SQLUSMALLINT),eNone,0,0,@Option);
      Sockfd.SendParam(3,sizeof(SQLUINTEGER),eNone,0,0,@Value);
      Result := Sockfd.SendExec;
      Sockfd.SendFuncDone;

     if (cstatus = Disconnected) or (cstatus = Timeout) then
     Result := -1;


end;

function _SQLGetConnectOption (ConnectionHandle : SQLHDBC;
                              Option : SQLUSMALLINT;
                              Value : SQLPOINTER)  : SQLRETURN ;
begin
     if (cstatus = Disconnected) or (cstatus = Timeout) then
     begin
     Result := -1;
     exit;
     end;


     Sockfd.SendFuncHeader(fSQLGetConnectOption);
     Sockfd.SendParam(1,sizeof(SQLHDBC),eNone,0,0,@ConnectionHandle);
     Sockfd.SendParam(2,sizeof(SQLUSMALLINT),eNone,0,0,@Option);
     Result := Sockfd.SendExec;
     Sockfd.SetrecvBuff(Value);
     Sockfd.SendRecvHeader(3);
     Sockfd.SendFuncDone;

     if (cstatus = Disconnected) or (cstatus = Timeout) then
     Result := -1;


end;

function _SQLGetData(StatementHandle : SQLHSTMT;
                    ColumnNumber : SQLUSMALLINT;
                    TargetType : SQLUSMALLINT;
                    TargetValue : SQLPOINTER;
                    BufferLength : SQLINTEGER;
                    var StrLen_or_Ind : SQLINTEGER) : SQLRETURN;
begin
end;


function _SQLGetFunctions(ConnectionHandle : SQLHDBC;
                         FunctionId : SQLUSMALLINT;
                         Supported : SQLPOINTER) : SQLRETURN;
begin
     if (cstatus = Disconnected) or (cstatus = Timeout) then
     begin
     Result := -1;
     exit;
     end;


         Sockfd.SendFuncHeader(fSQLGetFunctions);
         Sockfd.SendParam(1,sizeof(SQLHDBC),eNone,0,0,@ConnectionHandle);
         Sockfd.SendParam(2,sizeof(FunctionId),eNone,0,0,@FunctionId);
         Result := Sockfd.SendExec;
         Sockfd.SetRecvBuff(Supported);
         Sockfd.SendRecvHeader(3);
         Sockfd.SendFuncDone;

     if (cstatus = Disconnected) or (cstatus = Timeout) then
     Result := -1;


end;

function _SQLGetStmtOption(StatementHandle : SQLHSTMT;
                          Option : SQLUSMALLINT;
                          Value : SQLPOINTER) : SQLRETURN;
begin
     if (cstatus = Disconnected) or (cstatus = Timeout) then
     begin
     Result := -1;
     exit;
     end;


     Sockfd.SendFuncHeader(fSQLGetStmtOption);
     Sockfd.SendParam(1,sizeof(SQLHSTMT),eNone,0,0,@StatementHandle);
     Sockfd.SendParam(2,sizeof(SQLUSMALLINT),eNone,0,0,@Option);
     Result := Sockfd.SendExec;
     Sockfd.SetRecvBuff(Value);
     Sockfd.SendRecvHeader(3);
     Sockfd.SendFuncDone;

     if (cstatus = Disconnected) or (cstatus = Timeout) then
     Result := -1;



end;


function _SQLParamData(StatementHandle : SQLHSTMT ;
                      Value : SQLPOINTER ) : SQLRETURN;
begin

end;

function _SQLPutData(StatementHandle : SQLHSTMT;
                    Data : SQLPOINTER;
                    StrLen_or_Ind : SQLINTEGER) : SQLRETURN;
begin

end;


function _SQLStatistics(StatementHandle : SQLHSTMT;
                       CatalogName : SQLCHARptr ;
                       NameLength1 : SQLSMALLINT;
                       SchemaName : SQLCHARptr;
                       NameLength2 : SQLSMALLINT;
                       TableName  : SQLCHARptr;
                       NameLength3 : SQLSMALLINT;
                       Unique : SQLUSMALLINT;
                       Reserved : SQLUSMALLINT) : SQLRETURN;
begin
     if (cstatus = Disconnected) or (cstatus = Timeout) then
     begin
     Result := -1;
     exit;
     end;

      Sockfd.SendFuncHeader(fSQLStatistics);
      Sockfd.SendParam(1,sizeof(SQLHSTMT),eNone,0,0,@StatementHandle);
      Sockfd.SendParam(2,_Strlen(CatalogName),eNone,0,0,CatalogName);
      Sockfd.SendParam(3,sizeof(SQLSMALLINT),eNone,0,0,@NameLength1);
      Sockfd.SendParam(4,_Strlen(SchemaName),eNone,0,0,SchemaName);
      Sockfd.SendParam(5,sizeof(SQLSMALLINT),eNone,0,0,@NameLength2);
      Sockfd.SendParam(6,_Strlen(TableName),eNone,0,0,TableName);
      Sockfd.SendParam(7,sizeof(SQLSMALLINT),eNone,0,0,@NameLength3);
      Sockfd.SendParam(8,sizeof(SQLUSMALLINT),eNone,0,0,@Unique);
      Sockfd.SendParam(9,sizeof(SQLUSMALLINT),eNone,0,0,@Reserved);
      Result := Sockfd.SendExec;
      Sockfd.SendFuncDone;

     if (cstatus = Disconnected) or (cstatus = Timeout) then
     Result := -1;


end;

function _SQLExtendedFetch(hstmt        : SQLHSTMT;
                           fFetchType   : SQLUSMALLINT;
                           iRow         : SQLINTEGER;
                           var pcrow        : SQLUINTEGER;
                           var rgfRowStatus : SQLUSMALLINT) : SQLRETURN;
begin
end;
function _SQLMoreResults(hstmt : SQLHSTMT): SQLRETURN;
begin

end;


function _SQLNativeSQL(hdbc          : SQLHDBC;
                       szSqlStrIn    : SQLCHARptr;
                       cbSqlStrIn    : SQLINTEGER;
                       szSqlStr      : SQLCHARptr;
                       cbSqlStrMax   : SQLINTEGER;
                       var pcbSqlStr : SQLINTEGER) : SQLRETURN;
begin

end;

function _SQLNumParams(hstmt : SQLHSTMT ; var pcpar : SQLSMALLINT)
                                     : SQLRETURN;
begin
end;

function _SQLProcedures(hstmt           : SQLHSTMT;
                        szCatalogName   : SQLCHARptr;
                        cbCatalogName   : SQLSMALLINT;
                        szSchemaName    : SQLCHARptr;
                        cbSchemaName    : SQLSMALLINT;
                        szProcName      : SQLCHARptr;
                        cbProcName      : SQLSMALLINT)
                        : SQLRETURN;
begin

end;


function _SQLPrimaryKeys(hstmt         : SQLHSTMT;
                         szCatalogName : SQLCHARptr;
                         cbCatalogName : SQLSMALLINT;
                         szSchemaName  : SQLCHARptr;
                         cbSchemaName  : SQLSMALLINT;
                         szTableName   : SQLCHARptr;
                         cbTableName   : SQLSMALLINT): SQLRETURN;
begin

end;


function _SQLSetScrollOptions(hstmt         : SQLHSTMT;
                              fConcurrency  : SQLUSMALLINT;
                              crowKeyset    : SQLINTEGER;
                              crowRowset    : SQLSMALLINT)
                              : SQLRETURN;
begin

end;

function _SQLTablePrivileges(hstmt         : SQLHSTMT;
                             szCatalogName : SQLCHARptr;
                             cbCatalogName : SQLSMALLINT;
                             szSchemaName  : SQLCHARptr;
                             cbSchemaName  : SQLSMALLINT;
                             szTableName   : SQLCHARptr;
                             cbTableName   : SQLSMALLINT)
                               : SQLRETURN;
begin

end;


function _ConfigDSN(hwndParent : hwnd; fRequest : WORD;
                   const lpszDriver : Pchar;
                   const lpszAttributes : PChar) : BOOL ;

var
tempvalues : TStringlist;
ret : integer;
begin

     if fRequest <> 2 then begin
     Result := false;
     exit;
     end;


     tempvalues := TStringlist.Create;
     inifile := TInifile.Create('ODBCCONN.INI');
     inifile.ReadSectionValues('Settings',tempValues);
     ConfigForm := TConfigForm.Create(Application);

     ConfigForm.DSNName.Caption := StrPas(lpszDriver);

     ConfigForm.RDSN.text := tempvalues.values['RemoteDSN'];
     ConfigForm.UID.text := tempvalues.values['UID'];
     ConfigForm.RIP.text := tempvalues.values['APIServer'];
     ConfigForm.CSTR.text := tempvalues.values['ConnectString'];

     ret := ConfigForm.showmodal;

     if ret = mrOK then
     begin
     inifile.writestring('Settings','RemoteDSN',ConfigForm.RDSN.text);
     inifile.writestring('Settings','UID',ConfigForm.UID.text);
     inifile.writestring('Settings','APIServer',ConfigForm.RIP.text);
     inifile.writestring('Settings','ConnectString',ConfigForm.CSTR.text);
     end;

     ConfigForm.free;
     inifile.free;
     tempvalues.free;

     Result := true;

end;



procedure TForm1.ClientSocket1Connect(Sender: TObject;
  Socket: TSocketBase);
begin
     if Socket.Connected then
     cstatus := Connected;
     cwait := false;

     Sockfd.RegisterSocket((Socket as TStreamSocket));
end;

procedure TForm1.ClientSocket1TimeOut(Sender: TObject;
  Socket: TSocketBase);
begin
     cwait := false;
     cstatus := TimeOut;
end;



procedure endproc;
begin
     SecValues.Free;
     FreeMem(dataptr1,512);
     FreeMem(dsnname,512);
     dataptr1 := nil;
     if Assigned(Form1) then begin
     if Form1.ClientSocket1.Connected then begin
     try
        Form1.ClientSocket1.close;
     except
     begin
     end;
     end;
     end;
     Form1.close;
     Form1.Free;
     end;
end;

procedure TForm1.ClientSocket1Write(Sender: TObject; Socket: TSocketBase);
begin


     if Socket.Connected then
     Sockfd.ProcessWrite;

end;

procedure TForm1.ClientSocket1Read(Sender: TObject; Socket: TSocketBase);
begin
if Socket.Connected then 
Sockfd.ProcessRead;
end;


function _Strlen(str : Pchar) : Longint;
begin

     if str <> nil then
     Result := Strlen(str)+1
     else
     Result := 0;


end;

procedure TForm1.ClientSocket1Disconnect(Sender: TObject;
  Socket: TSocketBase);
var
i : integer;
begin


try
i := Socket.Incount;
if i > 0 then
begin
{showmessage('Bytes in readbuff = '+InttoStr(i));}
Socket.Recv(dataptr1,i);
end
except
{showmessage('Exception in Disconnect');}
end;

Socket.close;
cstatus := Disconnected;
Sockfd.ResetConnection;

end;

end.
